#include <stdio.h>
#include "q12.dat"                               // if your want "hanzi"
#include "jfc.c"                               // main lib.

FILE *fp;
unsigned char a[512][512], h[72][80],c;
float b[4096][4096];                           // ibit=-32
short b2[4096][4096];                           // ibit=16
unsigned char b1[4096][4096];
int   n1,n2,ibit,m1,m2;
float sky;
float d1,d2,d3,d4;
int   skyx,skyy;

getsky(x,y)
int x,y;
{
  return(x+y);
}

main(int ac, char **av)
{
  int i,j,k, i1,j1;
  float x,y;
  if(ac<2){ printf("\n\t **** show BOK ccd ****\n");
            printf("\n\t Usage: jfmap *.fit [0 0 0 0] [skyx skyy]\n\n\n");
            exit(0);
          }
  d1=d2=d3=d4=0.;
  skyx=skyy=0;
  if(ac>2)sscanf(av[2],"%f",&d1);
  if(ac>3)sscanf(av[3],"%f",&d2);
  if(ac>4)sscanf(av[4],"%f",&d3);
  if(ac>5)sscanf(av[5],"%f",&d4);
  if(ac>6)sscanf(av[6],"%d",&skyx);
  if(ac>7)sscanf(av[7],"%d",&skyy);
  fp=fopen(av[1],"rb"); if(!fp){ printf("%s not found!\n",av[1]); exit(0); }
  fread(h,72,80,fp); 
  sscanf(&h[1][23],"%d",&ibit);
  sscanf(&h[3][23],"%d",&n1);  
  sscanf(&h[4][23],"%d",&n2); 
  k=indexpos(h,"SKYADU  ",72); sky=0.;
  if(k!=72)sscanf(&h[k][20],"%f",&sky); 
  if(ibit==-32){ fread(b,n1*n2,4,fp); swap4(b,n1*n2*4); }
  if(ibit==16){ fread(b2,n1*n2,2,fp); swap2(b2,n1*n2*2);
                for(j=0;j<n2;j++)for(i=0;i<n1;i++)b[j][i]=b2[j][i]; }
  if(ibit==8){ fread(b1,n1*n2,1,fp); 
                for(j=0;j<n2;j++)for(i=0;i<n1;i++)b[j][i]=b1[j][i]; }
  fclose(fp);
  if(skyx!=0)sky=getsky(skyx,skyy);
  if(sky==0.)sky=getsky(n1/2,n2/2);
  for(j=0;j<n2;j+=8)for(i=0;i<n1;i+=8){ x=0.;
    for(j1=j;j1<j+8;j1++)for(i1=i;i1<i+8;i1++)x+=b[j1][i1]-sky;
    x*=0.1;
    x+=64.; if(x<0.)x=0.; if(x>255.)x=255.; a[j/8][i/8]=x;
  }
  x=m1=n1/8; y=m2=n2/8;
  jfbgft(200,235,255,  0,0,0);                   // set BG, front color RGB
  jfbegin("",m1,m2+24,5);                           // "" means no file out
  jfenv(0.,y,0.,x,0);                            // frame define
  jftext(130,505,av[1]);                          // draw label
  jfloadmap(a,m1,m2,0,0, 0,0);                   // show map
  c=getchar();
  jfend(0);
}
